<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/clap-3.2.16/src/builder/value_hint.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>value_hint.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../clap/index.html"><div class="logo-container"><img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../clap/index.html"><div class="logo-container">
                    <img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../clap/index.html">
                        <img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">std::str::FromStr</span>;

<span class="doccomment">/// Provide shell with hint on how to complete an argument.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// See [Arg::value_hint][crate::Arg::value_hint] to set this on an argument.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// See the `clap_complete` crate for completion script generation.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Overview of which hints are supported by which shell:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// | Hint                   | zsh | fish[^1]|</span>
<span class="doccomment">/// | ---------------------- | --- | ------- |</span>
<span class="doccomment">/// | `AnyPath`              | Yes | Yes     |</span>
<span class="doccomment">/// | `FilePath`             | Yes | Yes     |</span>
<span class="doccomment">/// | `DirPath`              | Yes | Yes     |</span>
<span class="doccomment">/// | `ExecutablePath`       | Yes | Partial |</span>
<span class="doccomment">/// | `CommandName`          | Yes | Yes     |</span>
<span class="doccomment">/// | `CommandString`        | Yes | Partial |</span>
<span class="doccomment">/// | `CommandWithArguments` | Yes |         |</span>
<span class="doccomment">/// | `Username`             | Yes | Yes     |</span>
<span class="doccomment">/// | `Hostname`             | Yes | Yes     |</span>
<span class="doccomment">/// | `Url`                  | Yes |         |</span>
<span class="doccomment">/// | `EmailAddress`         | Yes |         |</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [^1]: fish completions currently only support named arguments (e.g. -o or --opt), not</span>
<span class="doccomment">///       positional arguments.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>, <span class="ident">Copy</span>, <span class="ident">Clone</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">ValueHint</span> {
    <span class="doccomment">/// Default value if hint is not specified. Follows shell default behavior, which is usually</span>
    <span class="doccomment">/// auto-completing filenames.</span>
    <span class="ident">Unknown</span>,
    <span class="doccomment">/// None of the hints below apply. Disables shell completion for this argument.</span>
    <span class="ident">Other</span>,
    <span class="doccomment">/// Any existing path.</span>
    <span class="ident">AnyPath</span>,
    <span class="doccomment">/// Path to a file.</span>
    <span class="ident">FilePath</span>,
    <span class="doccomment">/// Path to a directory.</span>
    <span class="ident">DirPath</span>,
    <span class="doccomment">/// Path to an executable file.</span>
    <span class="ident">ExecutablePath</span>,
    <span class="doccomment">/// Name of a command, without arguments. May be relative to PATH, or full path to executable.</span>
    <span class="ident">CommandName</span>,
    <span class="doccomment">/// A single string containing a command and its arguments.</span>
    <span class="ident">CommandString</span>,
    <span class="doccomment">/// Capture the remaining arguments as a command name and arguments for that command. This is</span>
    <span class="doccomment">/// common when writing shell wrappers that execute anther command, for example `sudo` or `env`.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This hint is special, the argument must be a positional argument and have</span>
    <span class="doccomment">/// [`.multiple_values(true)`] and Command must use [`Command::trailing_var_arg(true)`]. The result is that the</span>
    <span class="doccomment">/// command line `my_app ls -la /` will be parsed as `[&quot;ls&quot;, &quot;-la&quot;, &quot;/&quot;]` and clap won&#39;t try to</span>
    <span class="doccomment">/// parse the `-la` argument itself.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// [`Command::trailing_var_arg(true)`]: crate::Command::trailing_var_arg</span>
    <span class="doccomment">/// [`.multiple_values(true)`]: crate::Arg::multiple_values()</span>
    <span class="ident">CommandWithArguments</span>,
    <span class="doccomment">/// Name of a local operating system user.</span>
    <span class="ident">Username</span>,
    <span class="doccomment">/// Host name of a computer.</span>
    <span class="doccomment">/// Shells usually parse `/etc/hosts` and `.ssh/known_hosts` to complete hostnames.</span>
    <span class="ident">Hostname</span>,
    <span class="doccomment">/// Complete web address.</span>
    <span class="ident">Url</span>,
    <span class="doccomment">/// Email address.</span>
    <span class="ident">EmailAddress</span>,
}

<span class="kw">impl</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">ValueHint</span> {
    <span class="kw">fn</span> <span class="ident">default</span>() -&gt; <span class="self">Self</span> {
        <span class="ident">ValueHint::Unknown</span>
    }
}

<span class="kw">impl</span> <span class="ident">FromStr</span> <span class="kw">for</span> <span class="ident">ValueHint</span> {
    <span class="kw">type</span> <span class="prelude-val">Err</span> <span class="op">=</span> <span class="ident">String</span>;
    <span class="kw">fn</span> <span class="ident">from_str</span>(<span class="ident">s</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span>, <span class="op">&lt;</span><span class="self">Self</span> <span class="kw">as</span> <span class="ident">FromStr</span><span class="op">&gt;</span><span class="ident">::Err</span><span class="op">&gt;</span> {
        <span class="prelude-val">Ok</span>(<span class="kw">match</span> <span class="kw-2">&amp;</span><span class="kw-2">*</span><span class="ident">s</span>.<span class="ident">to_ascii_lowercase</span>() {
            <span class="string">&quot;unknown&quot;</span> =&gt; <span class="ident">ValueHint::Unknown</span>,
            <span class="string">&quot;other&quot;</span> =&gt; <span class="ident">ValueHint::Other</span>,
            <span class="string">&quot;anypath&quot;</span> =&gt; <span class="ident">ValueHint::AnyPath</span>,
            <span class="string">&quot;filepath&quot;</span> =&gt; <span class="ident">ValueHint::FilePath</span>,
            <span class="string">&quot;dirpath&quot;</span> =&gt; <span class="ident">ValueHint::DirPath</span>,
            <span class="string">&quot;executablepath&quot;</span> =&gt; <span class="ident">ValueHint::ExecutablePath</span>,
            <span class="string">&quot;commandname&quot;</span> =&gt; <span class="ident">ValueHint::CommandName</span>,
            <span class="string">&quot;commandstring&quot;</span> =&gt; <span class="ident">ValueHint::CommandString</span>,
            <span class="string">&quot;commandwitharguments&quot;</span> =&gt; <span class="ident">ValueHint::CommandWithArguments</span>,
            <span class="string">&quot;username&quot;</span> =&gt; <span class="ident">ValueHint::Username</span>,
            <span class="string">&quot;hostname&quot;</span> =&gt; <span class="ident">ValueHint::Hostname</span>,
            <span class="string">&quot;url&quot;</span> =&gt; <span class="ident">ValueHint::Url</span>,
            <span class="string">&quot;emailaddress&quot;</span> =&gt; <span class="ident">ValueHint::EmailAddress</span>,
            <span class="kw">_</span> =&gt; <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format!</span>(<span class="string">&quot;unknown ValueHint: `{}`&quot;</span>, <span class="ident">s</span>)),
        })
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="clap" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>